#!/bin/bash
######### IBM 2016 , MD expansion fix for 3.4.0.0 Minor 29 GA ######
######### IBM 2016 , Big LUNs creation fix for 3.4.0.0 Minor 29 GA ######
function ExitLevel() {
RCode=$?
  if [ $RCode -ne 0 ]; then 
   tput setf 4
   echo "[FAIL...] Return Code # $RCode  " 2>&1
   echo "Please contact IBM support.."
   tput sgr0
   exit
 else      
   tput setf 2
   echo " [Fix applied successfully ...] "
   tput sgr0
  fi
}

function CheckVersion(){
version=$(cat /opt/dtc/app/sys/verinfo | grep "ProtecTIER version" | awk '{print $4}')
  if [ "$version" != "3.4.0.0" ]; then
	echo "This workaround is only for V3.4.0.0 "
	echo "Files wasn't changed"
	exit
  fi
}

function CheckMD5Sum(){
md5SumIsFsExtendAllowedOLD=$(md5sum /opt/dtc/install/lib/PT/Install/Condition/IsFsExtendAllowed.pm | awk '{print $1}')
md5sumCreatePartitionOLD=$(md5sum /opt/dtc/install/lib/PT/Install/ConfigItem/CreatePartition.pm | awk '{print $1}')
md5sumFsCreateOLD=$(md5sum /opt/dtc/install/lib/PT/Install/FsCreate.pm | awk '{print $1}')

md5SumIsFsExtendAllowedExpected="18c94fccc1dedeee5bc94b1013c853da"
md5sumCreatePartitionExpected="4b21616b1982c93597d48abf4581c53e"
md5sumFsCreateExpected="e6ad52570a3b2605301e3bcb1c80006e"

if [ "$md5SumIsFsExtendAllowedOLD" != "$md5SumIsFsExtendAllowedExpected" ] || [ "$md5sumCreatePartitionOLD" != "$md5sumCreatePartitionExpected" ] || [ "$md5sumFsCreateOLD" != "$md5sumFsCreateExpected" ];then
	echo "The original files have already been changed."
	echo "The files will be overwritten."
	echo "Press enter to continue..  " 
	read
fi
}

echo " ############################################### " 
echo " # MD expansion fix utility for 3.4.0 minor 29 # " 
echo " # Big LUNs creation fix for 3.4.0 minor 29    # "
echo " ############################################### "
echo ""
echo "This utility addresses some known issues documented in IBM TS7650 3.4.0.0 release note " 
echo "PTT-2455 and PTT-2387"
echo "Press enter to continue..  " 
read

CheckVersion
CheckMD5Sum

cp files/IsFsExtendAllowed.pm /opt/dtc/install/lib/PT/Install/Condition/
cp files/CreatePartition.pm /opt/dtc/install/lib/PT/Install/ConfigItem/
cp files/FsCreate.pm /opt/dtc/install/lib/PT/Install/
ExitLevel
